SystemOrganization addCategory: #'XPath-GemstoneCompatibility'!

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 3/2/2015 14:34'!
//!!= anObject
	^ anObject xPathNotEqualsString: self! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 3/2/2015 14:34'!
//* anObject
	^ self asXPathNumber * anObject asXPathNumber! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 3/2/2015 14:34'!
//+ anObject
	^ self asXPathNumber + anObject asXPathNumber! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 3/2/2015 14:34'!
//- anObject
	^ self asXPathNumber - anObject asXPathNumber! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 1/19/2015 11:11'!
/// anObject
	^ self asXPathNumber / anObject asXPathNumber! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 3/2/2015 14:34'!
//< anObject
	^ anObject xPathGreaterThanString: self! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 3/2/2015 14:38'!
//<= anObject
	^ (anObject xPathGreaterThanString: self)
		or: [anObject xPathEqualsString: self]! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 3/2/2015 14:38'!
//= anObject
	^ anObject xPathEqualsString: self! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 3/2/2015 14:38'!
//> anObject
	^ anObject xPathLessThanString: self! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 3/2/2015 14:38'!
//>= anObject
	^ (anObject xPathLessThanString: self)
		or: [anObject xPathEqualsString: self]! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 10/8/2015 09:06'!
//? aThreeArgumentBlockOrNumber
	XPathTypeException signal: 'Cannot filter strings'! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 10/30/2015 21:06'!
//\/ anObject
	XPathTypeException signal: 'Cannot union strings'! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 3/2/2015 14:38'!
//\\ anObject
	^ self asXPathNumber \\ anObject asXPathNumber! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 1/19/2015 11:11'!
asXPath
	^ XPath for: self! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 10/30/2015 21:07'!
asXPathAttributeNodeTestBlock
	"parses string as a node test to produce a node test block where attributes
	are the principal node type"
	^ (XPathNodeTestParser
		on: self
		for:
			(XPathStringNodeTestParserHandler defaultNodeTestParserContextClass:
				XPathNodeTestParserAttributeContext)) parse! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 1/19/2015 11:11'!
asXPathBoolean
	^ self notEmpty! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 10/30/2015 21:10'!
asXPathLocationPathRoot
	XPathTypeException signal: 'Cannot use boolean as location path root'! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 10/30/2015 21:07'!
asXPathNamespaceNodeTestBlock
	"parses string as a node test to produce a node test block where namespaces
	are the principal node type"
	^ (XPathNodeTestParser
		on: self
		for:
			(XPathStringNodeTestParserHandler defaultNodeTestParserContextClass:
				XPathNodeTestParserNamespaceContext)) parse! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 10/30/2015 21:09'!
asXPathNodeSet
	XPathTypeException signal: 'Cannot convert string to node set'! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 10/30/2015 21:07'!
asXPathNodeSetFilters
	^ #()! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 10/30/2015 21:06'!
asXPathNodeTestBlock
	^ (XPathNodeTestParser
		on: self
		for: XPathStringNodeTestParserHandler new) parse! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 4/7/2015 09:35'!
asXPathNumber
	^ Number xPathReadFrom: self readStream! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 1/19/2015 11:11'!
asXPathString
	^ self! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 10/30/2015 21:07'!
hasXPathNodeSetFilters
	^ false! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 1/19/2015 11:11'!
xPathEqualsBoolean: aBoolean
	^ self asXPathBoolean = aBoolean! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 1/19/2015 11:11'!
xPathEqualsNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each | self = each asXPathString]! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 1/19/2015 11:11'!
xPathEqualsNumber: aNumber
	^ self asXPathNumber = aNumber! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 1/19/2015 11:11'!
xPathEqualsString: aString
	^ self = aString! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 1/19/2015 11:11'!
xPathGreaterThanBoolean: aBoolean
	^ self asXPathNumber > aBoolean asXPathNumber! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 1/19/2015 11:11'!
xPathGreaterThanNodeSet: aNodeSet
	| number |
	
	number := self asXPathNumber.
	^ aNodeSet anySatisfy: [:each | number > each asXPathString asXPathNumber].! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 1/19/2015 11:11'!
xPathGreaterThanNumber: aNumber
	^ self asXPathNumber > aNumber! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 1/19/2015 11:11'!
xPathGreaterThanString: aString
	^ self asXPathNumber > aString asXPathNumber! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 1/19/2015 11:11'!
xPathLessThanBoolean: aBoolean
	^ self asXPathNumber < aBoolean asXPathNumber! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 1/19/2015 11:11'!
xPathLessThanNodeSet: aNodeSet
	| number |
	
	number := self asXPathNumber.
	^ aNodeSet anySatisfy: [:each | number < each asXPathString asXPathNumber].! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 1/19/2015 11:11'!
xPathLessThanNumber: aNumber
	^ self asXPathNumber < aNumber! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 1/19/2015 11:11'!
xPathLessThanString: aString
	^ self asXPathNumber < aString asXPathNumber! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 1/19/2015 11:11'!
xPathNotEqualsBoolean: aBoolean
	^ self asXPathBoolean ~= aBoolean! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 1/19/2015 11:11'!
xPathNotEqualsNodeSet: aNodeSet
	^ aNodeSet anySatisfy: [:each | self ~= each asXPathString]! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 1/19/2015 11:11'!
xPathNotEqualsNumber: aNumber
	^ self asXPathNumber ~= aNumber! !

!CharacterCollection methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 1/19/2015 11:11'!
xPathNotEqualsString: aString
	^ self ~= aString! !

!Number methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 3/3/2015 08:51'!
asXPathString
	self isNaN
		ifTrue: [^ 'NaN'].
	self isZero
		ifTrue: [^ '0'].
	self isInfinite
		ifTrue: [
			self < 0
				ifTrue: [^ '-Infinity']
				ifFalse: [^ 'Infinity']].
	^ self greaseString.! !

!XPathCompiler methodsFor: '*XPath-GemstoneCompatibility' stamp: 'monty 1/19/2015 11:14'!
compileSource: aString
	^ aString evaluate! !
